%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailDisjunctLeft{\ebpverif{ENT-LHS-OR}{
    \Hypo{\Delta_1 \vdash^{\kappa}_{V} \Delta_3 * \Delta_4}
    \Hypo{\Delta_2\vdash^{\kappa}_{V} \Delta_3 * \Delta_5}
    \Infer2{
      \Delta_1 \vee \Delta_2
      \vdash^{\kappa}_{V}
      \Delta_3 * (\Delta_4 \vee \Delta_5)}
  }} 


%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailDisjunctRight{\ebpverif{ENT-RHS-OR}{
    \Hypo{\Delta_1\vdash^{\kappa}_{V} \Delta_i * \Delta_i^{R}}
    \Hypo{i\in\{2,3\}}
    \Infer2{
      \Delta_1 \vdash^{\kappa}_{V}
      (\Delta_2 \vee \Delta_3) * \Delta_i^{R}}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailExistsLeft{\ebpverif{ENT-RHS-EX}{
    \Hypo{\Delta_1
      \vdash^{\kappa}_{V \cup \{\code{w}\}}
      ([\code{w}/\code{v}]\Delta_2) * \Delta}
    \Hypo{\fresh~\code{w}}
    \Infer2{
      \Delta_1 \vdash^{\kappa}_{V}
      (\exists \code{v} \cdot \Delta_2) * \Delta}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailExistsRight{\ebpverif{ENT-LHS-EX}{
    \Hypo{[\code{w}/\code{v}]\Delta_1
      \vdash^{\kappa}_{V}
      \Delta_2 * \Delta}
    \Hypo{\fresh~\code{w}}
    \Infer2{
      \exists \code{v} \cdot \Delta_1 \vdash^{\kappa}_{V}
      \Delta_2 * \Delta}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailEmp{\ebpverif{ENT-EMP}{
    \Hypo{\XPure_n(\kappa_1 * \kappa) \wedge  \pi_1
      \Rightarrow
       \exists V \cdot \pi_2}
    \Infer1{\kappa_1 \wedge \pi_1
      \vdash^{\kappa}_V
      \pi_2 * (\kappa_1 \wedge \pi_1)}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailMatch{\ebpverif{ENT-MATCH}{    
    \Hypo{
      \XPure_n(\node{u_1}{d}{\vect{v}_1} * \kappa_1 \wedge \pi_1)
      \Rightarrow \btt{u_1}{=}\btt{u_2}}
    \Infer[no rule]1{
      \rho = [\btt{\vect{v}_1}/\btt{\vect{v}_2}] \quad\quad
      \kappa_1 \wedge \pi_1 \wedge \freeEqn(\rho, V)
      \vdash_{V-\{\btt{\vect{v}_2}\}}^{\kappa * \node{u_1}{d}{\vect{v}_1}}
      \rho(\kappa_2 \wedge \pi_2) * \Delta }
    \Infer1{\node{u_1}{d}{\vect{v}_1} * \kappa_1 \wedge \pi_1
      \vdash_V^{\kappa}
      (\node{u_2}{d}{\vect{v}_2} * \kappa_2 \wedge \pi_2) * \Delta}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailUnfold{\ebpverif{ENT-UNFOLD}{
    \Hypo{
      \XPure_n(\view{\pred}{u_1, \vect{v}_1} * \kappa_1 \wedge \pi_1)
      \Rightarrow \btt{u_1}{=}\btt{u_2}}
    \Infer[no rule]1{
      \unfold(\view{\pred}{u_1,\vect{v}_1}) * \kappa_1 \wedge \pi_1
      \vdash^{\kappa}_V
      (\node{u_2}{d}{\vect{v}_2} * \kappa_2 \wedge \pi_2) * \Delta}
    \Infer1{
      \view{\pred}{u_1, \vect{v}_1} * \kappa_1 \wedge \pi_1
      \vdash^{\kappa}_V
      (\node{u_2}{d}{\vect{v}_2} * \kappa_2 \wedge \pi_2) * \Delta}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageEntailFold{\ebpverif{ENT-FOLD}{
    \Hypo{
      (\Delta^r, \kappa^r, \pi^r) \in \fold^{\kappa}(\node{u_1}{d}{\vect{v}_1}
      * \kappa_1 \wedge \pi_1, \view{\pred}{u_2, \vect{v}_2})}
    \Hypo{(\pi^1, \pi^c)=\splitKW^{\{\btt{\vect{v}_2}\}}_V(\pi^r)}
    \Infer[no rule]2
    {\XPure_n(\node{u_1}{d}{\vect{v}_1} * \kappa_1 * \pi_1
      \Rightarrow \btt{u_1}{=}\btt{u_2}) \quad\quad
      \Delta^r \wedge \pi^a \vdash^{\kappa^r}_V (\kappa_2 \wedge \pi_2
      \wedge \pi^c) * \Delta}
    \Infer1{
      \node{u_1}{d}{\vect{v}_1} * \kappa_1 \wedge \pi_1
      \vdash^{\kappa}_V
      (\view{\pred}{u_2, \vect{v}_2} * \kappa_2 \wedge \pi_2) * \Delta}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageFolding{\hbox{
    \begin{prooftree}
      \Hypo{\view{\pred}{\vect{v}} \defeq \Phi ~\inv~ \pi}
      \Hypo{
        \kappa \wedge \pi \vdash^{\kappa'}_{\{\btt{u},\btt{\vect{v}}\}}
        [\vect{\code{u}}/\vect{\code{v}}]\Phi *
        \{(\Delta_i, \kappa_i, V_i, \pi_i)\}^n_{i=1}}
      \Hypo{W_i = V_i - \{\btt{\vect{v}}, \btt{u}\}}
      \Infer3{
        \fold^{\kappa}(\kappa \wedge \pi, \view{\pred}{\vect{u}}) \defeq
        \{(\Delta_i, \kappa_i, \exists W_i \cdot \pi_i)\}^n_{i=1}}
    \end{prooftree}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageUnfolding{\hbox{
    \begin{prooftree}
    \Hypo{
      \view{\pred}{\vect{v}} \defeq \Phi~\inv~ \pi}
    \Infer1{
      \unfold(\view{\pred}{\vect{u}}) \defeq
      [\vect{\code{u}}/\vect{\code{v}}]\Phi}
    \end{prooftree}
  }}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageInvBase{\hbox{
  \begin{prooftree}
    \Hypo{\view{\pred}{\vect{v}} \defeq \Phi~\inv~\pi_0}
  \Infer1
  {\Inv_0(\view{\pred}{\vect{v}}) \defeq \pi_0}
  \end{prooftree}}
}

%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageInvRecursive{\hbox{
  \begin{prooftree}
    \Hypo{\view{\pred}{\vect{v}} \defeq \Phi~\inv~\pi_0}
  \Infer1
  {\Inv_n(\view{\pred}{\vect{v}}) \defeq \XPure_{n-1}(\Phi)}
  \end{prooftree}}
}


%% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
\newcommand\minipageXPureIsPred{\hbox{
  \begin{prooftree}
    \Hypo{\Inv_n(\view{\pred}{\vect{v}} \rangle) =
      \bigvee^n_{i{=}1}(\exists \vect{\code{u}}_i \cdot \pi_i)}
    \Infer1{
      \XPure_n(\view{\pred}{\vect{v}}) \defeq
      \bigvee^n_{i{=}1}(\exists \vect{\code{u}}_i \cdot \pi_i)}
  \end{prooftree}}
}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "main"
%%% End:
